#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_GEPI_KOD_MERET (0x400-0x64)

FILE *bemeneti_fajl;
FILE *kimeneti_fajl;
FILE *kisegito_kimeneti_fajl;

int gepi_kod_meret = 0;
int sorszam;

void vegzetes_hiba(char* vegzetes_hiba_szoveg)
{
  printf("Hiba a %i. sorban: %s\n", sorszam, vegzetes_hiba_szoveg);
  exit(1);
}

void adj_hozza_gepi_kodot(unsigned char kod_bajt)
{
  if (gepi_kod_meret >= MAX_GEPI_KOD_MERET)
    vegzetes_hiba("A program nem fer be a memoriaba");
  fprintf(kimeneti_fajl, "%02X", kod_bajt);
  fprintf(kisegito_kimeneti_fajl, "%02X ", kod_bajt);
  ++gepi_kod_meret;
}

void adj_hozza_jump_utasitast(unsigned char utasitas_bajt, char* sor_maradeka)
{
  unsigned int cim;
  if (sscanf(sor_maradeka, "%x", &cim) != 1)
    vegzetes_hiba("Ertelmezhetetlen parameterlista (jump)");
  if (cim > 0x400)
    vegzetes_hiba("Hibas ugrasi cim");
  adj_hozza_gepi_kodot(utasitas_bajt);
  adj_hozza_gepi_kodot(cim >> 8);
  adj_hozza_gepi_kodot(cim & 0xFF);
}

void adj_hozza_ketparameteres_utasitast(unsigned char utasitas_bajt, char* sor_maradeka)
{
  unsigned int parameter_1;
  unsigned int parameter_2;
  if (sscanf(sor_maradeka, "[%x] [%x]", &parameter_1, &parameter_2) == 2)
  {
    adj_hozza_gepi_kodot(utasitas_bajt);
    adj_hozza_gepi_kodot(parameter_1 >> 8);
    adj_hozza_gepi_kodot(parameter_1 & 0xFF);
    adj_hozza_gepi_kodot(parameter_2 >> 8);
    adj_hozza_gepi_kodot(parameter_2 & 0xFF);
  }
  else if (sscanf(sor_maradeka, "[%x] $%x", &parameter_1, &parameter_2) == 2)
  {
    adj_hozza_gepi_kodot(utasitas_bajt + 1);
    adj_hozza_gepi_kodot(parameter_1 >> 8);
    adj_hozza_gepi_kodot(parameter_1 & 0xFF);
    adj_hozza_gepi_kodot(parameter_2);
  }
  else
    vegzetes_hiba("Ertelmezhetetlen parameterlista (nem jump)");
}

void ertelmezd_a_forraskod_sort(char* sor)
{
       if (!strncmp("MOV ", sor, 4))
    adj_hozza_ketparameteres_utasitast(0x00, sor + 4);
  else if (!strncmp("ADD ", sor, 4))
    adj_hozza_ketparameteres_utasitast(0x02, sor + 4);
  else if (!strncmp("SUB ", sor, 4))
    adj_hozza_ketparameteres_utasitast(0x04, sor + 4);
  else if (!strncmp("JMP ", sor, 4))
    adj_hozza_jump_utasitast(0x06, sor + 4);
  else if (!strncmp("JZ ", sor, 3))
    adj_hozza_jump_utasitast(0x07, sor + 3);
  else if (!strncmp("JC ", sor, 3))
    adj_hozza_jump_utasitast(0x08, sor + 3);
  else if (!strncmp("END", sor, 3))
    adj_hozza_gepi_kodot(0x0A);
  else if (!strncmp("WAIT", sor, 4))
    adj_hozza_gepi_kodot(0x09);
  else
    vegzetes_hiba("Ismeretlen utasitas");
}

void ertelmezd_a_forraskod_fajlt()
{
  char sor[100] = {};
  while(1)
  {
    if(!fgets(sor, 100, bemeneti_fajl))
      break;
    ++sorszam;
    if (sor[0] == 0 || sor[0] == '\r')
        continue;
    if (sor[0] == '#')
    {
      fprintf(kisegito_kimeneti_fajl, "%03X: %s", gepi_kod_meret + 0x64, sor);
      continue;
    }
    fprintf(kisegito_kimeneti_fajl, "%03X: # %s", gepi_kod_meret + 0x64, sor);
    fprintf(kisegito_kimeneti_fajl, "%03X: ", gepi_kod_meret + 0x64);
    ertelmezd_a_forraskod_sort(sor);
    fprintf(kisegito_kimeneti_fajl, "\n");
  }
}

int main(int argc, char** argv)
{
  if (argc != 4)
    vegzetes_hiba("A programot pontosan 3 fajlnev parameterrel kell megnyitni: bemenet kimenet kisegito_kimenet.");

  bemeneti_fajl = fopen(argv[1], "r");
  if (!bemeneti_fajl)
    vegzetes_hiba("Nem sikerult megnyitni a bemeneti fajlt");
  kimeneti_fajl = fopen(argv[2], "w");
  if (!kimeneti_fajl)
    vegzetes_hiba("Nem sikerult megnyitni a kimeneti fajlt");
  kisegito_kimeneti_fajl = fopen(argv[3], "w");
  if (!kimeneti_fajl)
    vegzetes_hiba("Nem sikerult megnyitni a kimeneti fajlt");
  ertelmezd_a_forraskod_fajlt();
  fclose(bemeneti_fajl);
  fclose(kimeneti_fajl);

  return 0;
}
