#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include <signal.h>

#define MAX_GEPI_KOD_MERET (0x400-0x64)

char* gep_allapot_nevek[] = {
  "All",
  "Fut (Ctrl-C leallitja)",
  "Hiba",
  "Leptet"
};
#define GEP_ALLAPOT_ALL 0
#define GEP_ALLAPOT_FUT 1
#define GEP_ALLAPOT_HIBA 2
#define GEP_ALLAPOT_LEPTET 3

#define UTASITAS_MOV_MEMORIA 0
#define UTASITAS_MOV_SZAM 1
#define UTASITAS_ADD_MEMORIA 2
#define UTASITAS_ADD_SZAM 3
#define UTASITAS_SUB_MEMORIA 4
#define UTASITAS_SUB_SZAM 5
#define UTASITAS_JMP 6
#define UTASITAS_JZ 7
#define UTASITAS_JC 8
#define UTASITAS_WAIT 9
#define UTASITAS_END 0xA


FILE *bemeneti_fajl;
unsigned char memoria[0x410] = {};
int gep_allapot = 0;
unsigned int aktualis_utasitas_cime = 0x64;
char utolso_eredmeny_0 = 0;
char utolso_eredmeny_tulcsordult = 0;
unsigned figyelt_cim = 0;
char* utolso_hiba = "";

void hiba(char* hiba_szoveg)
{
  utolso_hiba = hiba_szoveg;
  gep_allapot = GEP_ALLAPOT_HIBA;
}

unsigned int hexadecimalis_karakter_szamkent(char karakter)
{
  if (karakter >= '0' && karakter <= '9')
    return karakter - '0';
  if (karakter >= 'A' && karakter <= 'F')
    return karakter + 10 - 'A';
  if (karakter >= 'a' && karakter <= 'f')
    return karakter + 10 - 'a';
  hiba("Ismeretlen (nem hexadecimalis) karakter a fajlban");
  return 0;
}

void toltsd_be_a_bemeneti_fajlt()
{
  int kovetkezo_bajt_helye = 0x64;
  char bajtot_jelkepezo_ket_karakter[2];
  unsigned char beolvasott_bajt;
  int beolvasott_karakterek = 0;
  gep_allapot = GEP_ALLAPOT_ALL;

  while(1)
  {
    if (kovetkezo_bajt_helye > 0x400)
      hiba("Tul nagy bemeneti fajl");
    beolvasott_karakterek = fread(bajtot_jelkepezo_ket_karakter, 1, 2, bemeneti_fajl);
    if (beolvasott_karakterek == 0)
      break;
    if (beolvasott_karakterek == 1)
    {
      hiba("Paratlan szamu hexadecimalis karakter a fajlban");
      break;
    }
    beolvasott_bajt =
      hexadecimalis_karakter_szamkent(bajtot_jelkepezo_ket_karakter[0]) * 16 +
      hexadecimalis_karakter_szamkent(bajtot_jelkepezo_ket_karakter[1]);
    memoria[kovetkezo_bajt_helye] = beolvasott_bajt;
    ++kovetkezo_bajt_helye;
  }
  aktualis_utasitas_cime = 0x64;
  utolso_eredmeny_0 = 0;
  utolso_eredmeny_tulcsordult = 0;
}

void torold_a_kepernyot()
{
  printf("\e[2J\n");
}

void jelenitsd_meg_a_gep_allapotot()
{
  int i, j;
  torold_a_kepernyot();
  printf("\n");
  printf("  +----------+\n");
  for (i = 0; i < 10; ++i)
  {
      printf("  |");
      for (j=0; j<10; ++j)
      {
        unsigned char kiirando_bajt = memoria[i*10 + j];
        if (kiirando_bajt>0x20 && kiirando_bajt<128)
          putchar(kiirando_bajt);
        else
          putchar(' ');
      }
      printf("|  ");
      if (i == 3) printf("Allapot: %s", gep_allapot_nevek[gep_allapot]);
      if (i == 4) printf("Aktualis utasitas cime: %03x", aktualis_utasitas_cime);
      if (i == 5) printf("Aktualis utasitas     :  %02x", memoria[aktualis_utasitas_cime]);
      if (i == 6) printf("Figyelt memoriacim    : %03x", figyelt_cim);
      if (i == 7) printf("Figyelt memoria erteke:  %02x", memoria[figyelt_cim]);
      printf("\n");
  }
  printf("  +----------+\n\n");
  if (utolso_hiba[0])
    printf("HIBA: %s\n", utolso_hiba);
}

unsigned olvasd_a_memoriat(unsigned memoriacim)
{
  if (memoriacim > 0x400)
  {
    hiba("Hibas memoriacim olvasaskor");
    return 0;
  }
  return memoria[memoriacim];
}

void ird_a_memoriat(unsigned memoriacim, unsigned ertek)
{
  if (memoriacim > 0x400)
  {
    hiba("Hibas memoriacim iraskor");
    return;
  }
  memoria[memoriacim] = ertek & 0xFF;
  utolso_eredmeny_0 = ((ertek & 0xFF) == 0);
  utolso_eredmeny_tulcsordult = (ertek > 0xFF);
}

void hajts_vegre_egy_utasitast(unsigned char utasitas, unsigned parameter_1, unsigned parameter_2)
{
  switch(utasitas)
  {
    case UTASITAS_MOV_MEMORIA:
      ird_a_memoriat(
        parameter_1,
        olvasd_a_memoriat(parameter_2)
      );
      break;
    case UTASITAS_MOV_SZAM:
      ird_a_memoriat(
        parameter_1,
        parameter_2
      );
      break;
    case UTASITAS_ADD_MEMORIA:
      ird_a_memoriat(
        parameter_1,
        olvasd_a_memoriat(parameter_1) + olvasd_a_memoriat(parameter_2)
      );
      break;
    case UTASITAS_ADD_SZAM:
      ird_a_memoriat(
        parameter_1,
        olvasd_a_memoriat(parameter_1) + parameter_2
      );
      break;
    case UTASITAS_SUB_MEMORIA:
      ird_a_memoriat(
        parameter_1,
        olvasd_a_memoriat(parameter_1) - olvasd_a_memoriat(parameter_2)
      );
      break;
    case UTASITAS_SUB_SZAM:
      ird_a_memoriat(
        parameter_1,
        olvasd_a_memoriat(parameter_1) - parameter_2
      );
      break;
    case UTASITAS_JMP:
      if (parameter_1 > 0x400)
        hiba("Hibas cim ugraskor (JMP)");
      else
        aktualis_utasitas_cime = parameter_1;
      break;
    case UTASITAS_JZ:
      if (utolso_eredmeny_0)
        if (parameter_1 > 0x400)
          hiba("Hibas cim ugraskor (JZ)");
        else
          aktualis_utasitas_cime = parameter_1;
      break;
    case UTASITAS_JC:
      if (utolso_eredmeny_tulcsordult)
        if (parameter_1 > 0x400)
          hiba("Hibas cim ugraskor (JC)");
        else
          aktualis_utasitas_cime = parameter_1;
      break;
    case UTASITAS_WAIT:
      usleep(100000);
      break;
    case UTASITAS_END:
      gep_allapot = GEP_ALLAPOT_ALL;
      break;
    default:
      hiba("Hibas utasitas");
  }
}

unsigned olvass_be_memoriacim_parametert()
{
  unsigned char elso_bajt;
  unsigned char masodik_bajt;
  elso_bajt  = olvasd_a_memoriat(aktualis_utasitas_cime);
  ++aktualis_utasitas_cime;
  masodik_bajt  = olvasd_a_memoriat(aktualis_utasitas_cime);
  ++aktualis_utasitas_cime;
  return (elso_bajt << 8) + masodik_bajt;
}

unsigned olvass_be_szam_parametert()
{
  unsigned char memoria_ertek = olvasd_a_memoriat(aktualis_utasitas_cime);
  ++aktualis_utasitas_cime;
  return memoria_ertek;
}

void futtasd_a_programot()
{
  unsigned char utasitas;
  unsigned int parameter_1;
  unsigned int parameter_2;
  int utolso_megjelenites = 0;
  utolso_hiba = "";
  
  do
  {
    utasitas = olvasd_a_memoriat(aktualis_utasitas_cime);
    ++aktualis_utasitas_cime;
    switch(utasitas)
    {
      case UTASITAS_MOV_MEMORIA:
      case UTASITAS_ADD_MEMORIA:
      case UTASITAS_SUB_MEMORIA:
        parameter_1 = olvass_be_memoriacim_parametert();
        parameter_2 = olvass_be_memoriacim_parametert();
        break;

      case UTASITAS_MOV_SZAM:
      case UTASITAS_ADD_SZAM:
      case UTASITAS_SUB_SZAM:
        parameter_1 = olvass_be_memoriacim_parametert();
        parameter_2 = olvass_be_szam_parametert();
        break;

      case UTASITAS_JMP:
      case UTASITAS_JZ:
      case UTASITAS_JC:
        parameter_1 = olvass_be_memoriacim_parametert();
        break;
    }
    ++utolso_megjelenites;
    if (utolso_megjelenites >= 100 || utasitas == UTASITAS_WAIT)
    {
      utolso_megjelenites = 0;
      jelenitsd_meg_a_gep_allapotot();
    }
    hajts_vegre_egy_utasitast(utasitas, parameter_1, parameter_2);
  }
  while(gep_allapot == GEP_ALLAPOT_FUT);
}

void fomenu()
{
  char parancs[100];
  int parancs_hossz;
  while (1)
  {
    jelenitsd_meg_a_gep_allapotot();
    printf("Parancs? (L fajlnev: betoltes, R: futtatas, S: leptetes, M cim: figyelt memoriacim allitasa, Q: kilepes)\n");
    fgets(parancs, sizeof(parancs), stdin);
    parancs_hossz = strlen(parancs);
    if (parancs_hossz > 0 && parancs[parancs_hossz-1] == '\n')
    {
      parancs[parancs_hossz-1] = 0;
      --parancs_hossz;
    }
    if (!parancs_hossz)
      continue;
    utolso_hiba = "";
    switch(parancs[0])
    {
      case 'L': case 'l':
        if (parancs_hossz <= 2)
        {
          utolso_hiba = "Hianyzo fajlnev parameter";
          break;
        }
        bemeneti_fajl = fopen(parancs + 2, "r");
        if (!bemeneti_fajl)
        {
          utolso_hiba = "Nem sikerult megnyitni a bemeneti fajlt";
          break;
        }
        toltsd_be_a_bemeneti_fajlt();
        fclose(bemeneti_fajl);
        break;
      case 'R': case 'r':
        if (gep_allapot == GEP_ALLAPOT_HIBA)
        {
          utolso_hiba = "A gep hibas allapotban van. L paranccsal lehet visszaallitani";
          break;
        }
        gep_allapot = GEP_ALLAPOT_FUT;
        futtasd_a_programot();
        break;
      case 'S': case 's':
        if (gep_allapot == GEP_ALLAPOT_HIBA)
        {
          utolso_hiba = "A gep hibas allapotban van. L paranccsal lehet visszaallitani";
          break;
        }
        gep_allapot = GEP_ALLAPOT_LEPTET;
        futtasd_a_programot();
        break;
      case 'M': case 'm':
        if (sscanf(parancs+2, "%x", &figyelt_cim) != 1)
          utolso_hiba = "Hibas memoriacim formatum";
        else if (figyelt_cim > 0x400)
        {
          figyelt_cim = 0;
          utolso_hiba = "Hibas figyelendo cim";
        }
        break;
      case 'Q': case 'q':
        printf("Kilepes. Viszlat!\n");
        exit(0);
      default:
        utolso_hiba = "Hibas parancs";
    }
  }
}

void ctrl_c_kezelo(int sig)
{
  if (gep_allapot == GEP_ALLAPOT_FUT)
    gep_allapot = GEP_ALLAPOT_ALL;
}

int main(int argc, char** argv)
{
  signal(SIGINT, ctrl_c_kezelo);
  fomenu();
  return 0;
}
